# eric5.UI.Previewers.PreviewerHTML

Module implementing a previewer widget for HTML, Markdown and ReST files.

### Global Attributes

None

### Classes

PreviewProcessingThread | Class implementing a thread to process some text into HTML usable by the previewer view.
PreviewerHTML | Class implementing a previewer widget for HTML, Markdown and ReST files.
_StrikeThroughExtension | Class is placed here, because it depends on imported markdown, and markdown import is lazy.

### Functions

None

## PreviewProcessingThread

Class implementing a thread to process some text into HTML usable by the previewer view.

### Signals

htmlReady(str,str)
  emitted with the file name and processed HTML to signal the availability of the processed HTML

### Derived from

QThread

### Class Attributes

None

### Class Methods

None

### Methods

PreviewProcessingThread | Constructor
__convertMarkdown | Private method to convert Markdown text into HTML.
__convertReST | Private method to convert ReST text into HTML.
__getHtml | Private method to process the given text depending upon the given language.
__processSSI | Private method to process the given text for SSI statements.
process | Public method to convert the given text to HTML.
run | Public thread method to convert the stored data.

### Static Methods

None

#### PreviewProcessingThread (Constructor)

PreviewProcessingThread(parent=None)

Constructor

parent
  reference to the parent object (QObject)

#### PreviewProcessingThread.__convertMarkdown

__convertMarkdown(text)

Private method to convert Markdown text into HTML.

text
  text to be processed (string)

Returns:
  processed HTML (string)

#### PreviewProcessingThread.__convertReST

__convertReST(text)

Private method to convert ReST text into HTML.

text
  text to be processed (string)

Returns:
  processed HTML (string)

#### PreviewProcessingThread.__getHtml

__getHtml(language, text, ssiEnabled, filePath, rootPath)

Private method to process the given text depending upon the given language.

language
  language of the text (string)
text
  to be processed (string)
ssiEnabled
  flag indicating to do some (limited) SSI processing (boolean)
filePath
  file path of the text (string)
rootPath
  root path to be used for SSI processing (str)

Returns:
  processed HTML text (string)

#### PreviewProcessingThread.__processSSI

__processSSI(txt, filename, root)

Private method to process the given text for SSI statements.

Note: Only a limited subset of SSI statements are supported.

txt
  text to be processed (string)
filename
  name of the file associated with the given text (string)
root
  directory of the document root (string)

Returns:
  processed HTML (string)

#### PreviewProcessingThread.process

process(filePath, language, text, ssiEnabled, rootPath)

Public method to convert the given text to HTML.

filePath
  file path of the text (string)
language
  language of the text (string)
text
  text to be processed (string)
ssiEnabled
  flag indicating to do some (limited) SSI processing (boolean)
rootPath
  root path to be used for SSI processing (str)

#### PreviewProcessingThread.run

run()

Public thread method to convert the stored data.

Up

## PreviewerHTML

Class implementing a previewer widget for HTML, Markdown and ReST files.

### Derived from

QWidget, Ui_PreviewerHTML

### Class Attributes

None

### Class Methods

None

### Methods

PreviewerHTML | Constructor
__restoreScrollBarPositions | Private method to restore scroll bar positions for a previewed editor.
__saveScrollBarPositions | Private method to save scroll bar positions for a previewed editor.
__setHtml | Private method to set the HTML to the view and restore the scroll bars positions.
__setJavaScriptEnabled | Private method to enable/disable JavaScript.
on_jsCheckBox_clicked | Private slot to enable/disable JavaScript.
on_previewView_linkClicked | Private slot handling the clicking of a link.
on_previewView_titleChanged | Private slot to handle a change of the title.
on_ssiCheckBox_clicked | Private slot to enable/disable SSI.
processEditor | Public slot to process an editor's text.
shutdown | Public method to perform shutdown actions.

### Static Methods

None

#### PreviewerHTML (Constructor)

PreviewerHTML(parent=None)

Constructor

parent
  reference to the parent widget (QWidget)

#### PreviewerHTML.__restoreScrollBarPositions

__restoreScrollBarPositions()

Private method to restore scroll bar positions for a previewed editor.

#### PreviewerHTML.__saveScrollBarPositions

__saveScrollBarPositions()

Private method to save scroll bar positions for a previewed editor.

#### PreviewerHTML.__setHtml

__setHtml(filePath, html)

Private method to set the HTML to the view and restore the scroll bars positions.

filePath
  file path of the previewed editor (string)
html
  processed HTML text ready to be shown (string)

#### PreviewerHTML.__setJavaScriptEnabled

__setJavaScriptEnabled(enable)

Private method to enable/disable JavaScript.

enable
  flag indicating the enable state (boolean)

#### PreviewerHTML.on_jsCheckBox_clicked

on_jsCheckBox_clicked(checked)

Private slot to enable/disable JavaScript.

checked
  state of the checkbox (boolean)

#### PreviewerHTML.on_previewView_linkClicked

on_previewView_linkClicked(url)

Private slot handling the clicking of a link.

url
  url of the clicked link (QUrl)

#### PreviewerHTML.on_previewView_titleChanged

on_previewView_titleChanged(title)

Private slot to handle a change of the title.

title
  new title (string)

#### PreviewerHTML.on_ssiCheckBox_clicked

on_ssiCheckBox_clicked(checked)

Private slot to enable/disable SSI.

checked
  state of the checkbox (boolean)

#### PreviewerHTML.processEditor

processEditor(editor=None)

Public slot to process an editor's text.

editor
  editor to be processed (Editor)

#### PreviewerHTML.shutdown

shutdown()

Public method to perform shutdown actions.

Up

## _StrikeThroughExtension

Class is placed here, because it depends on imported markdown, and markdown import is lazy.

(see http://achinghead.com/ python-markdown-adding-insert-delete.html this page for details)

### Derived from

markdown.Extension

### Class Attributes

DEL_RE

### Class Methods

None

### Methods

extendMarkdown |

### Static Methods

None

#### _StrikeThroughExtension.extendMarkdown

extendMarkdown(md, md_globals)
Up